//#include "AccCar.h"
//#include "signal_wrapper.h"
//
//// Update is running at 1000ms (1 second cycles)
//#define TICK 1000
//
//// Acc monitors 17 meters ahead
//#define MONITOR_DIST 17
//
//// Acc maintains a safety gap of 2 meters
//#define SAFETY_GAP 2
//
//
//extern int car_position;
//
//AccCar::AccCar(int id) {
//    this->id = id;   
//    
//    // Include any other necessary initialization
//    // ...
//    // ...
//    
//    thread = NULL; // Initialize thread to null, since the starting of the simulation is done in reset(-)
//}
//
//int AccCar::acc_is_simulating()
//{
//    return acc_simulation;
//}
//
//void AccCar::update_pos()
//{
//            // where should we be? in case we have already been adjusting our speed
//        int assigned_position = this->position+this->assigned_speed;
//        
//        int desired_speed;
//        int desired_position;
//        
//        if( assigned_position >= ( car_position - SAFETY_GAP ) )
//        {
//            // no we can not find the max speed we can go
//            // find the speed we can safely go this will ALWAYS be SAFETY_GAP or more in the negative direction
//            int speed_diff = car_position - (assigned_position + SAFETY_GAP);
//            assert(speed_diff <= SAFETY_GAP);
//            // set desired speed 
//            desired_speed = speed_diff + this->assigned_speed;
//            // adjust our speed to not collide
//            desired_position = desired_speed + this->position;
//               
//            //printf(" adjusted max speed to not collide %d -> %d \r\n",desired_position,desired_speed);
//        }
//        // last condition saying we can go assigned speed
//        else if( assigned_position <=  (car_position - SAFETY_GAP ) )
//        {
//            desired_position = this->assigned_speed + this->position;
//            desired_speed = this->assigned_speed;
//            //printf("max speed!!! %d -> %d \r\n",desired_position,desired_speed);
//        }
//        // crash, we should not enter
//        else
//        {
//            assert(0);
//        }
//        
//        this->position = desired_position;
//        this->speed = desired_speed;
//}
//
//void AccCar::update() {
//    while (true) {
//        
//        // wait for the signal from the main thread to update
//        uint32_t flags = wait_for_signal( ACC_SIGNAL );
//        if( flags == ACC_SIGNAL )
//        {
//            update_pos();
//        }
//        else
//        {
//            assert(0);    
//        }
//        
//        if(this->position >= ROADLENGTH)
//        {
//            // notify to end simulation and terminate yourself
//            acc_simulation = 0;
//            send_signal( ACC_UPDATE_MAIN_SIGNAL );
//            assert( thread->terminate() == MBED_SUCCESS );
//        }
//
//        // return to car thread he will notify main
//        send_signal( ACC_UPDATE_MAIN_SIGNAL );
//    }
//}
//
//void AccCar::reset(int speed) {
//    // handle any necessary coordination with main thread
//    
//    // reset any other attributes that may be necessary
//    // ...
//    // ...
//    
//    if (thread != NULL) {   // Clear out the existing thread, if it exists, since we don't know how long it has waited for
//        delete thread;
//    }
//    
//    thread = new Thread();                         // Create a new thread for the car
//    thread->start( callback(this, &AccCar::update) ); // Start the thread with the car's update method
//    
//    acc_simulation = 1;
//    this->position = 0;
//    this->speed = speed;
//    this->assigned_speed = speed;
//}