//#include "mbed.h"
//#include <cctype>
//#include "Car.h"
//#include "AccCar.h"
//#include "TextLCD.h"
//#include "signal_wrapper.h"
//
//Serial pc(USBTX, USBRX);    // The connection to USB
//TextLCD lcd(p15, p16, p17, p18, p19, p20, TextLCD::LCD16x2 ); // rs, e, d4-d7
//
//#define MIN_CAR_POSITION 20
//#define MAX_CAR_POSITION 40
//#define MAX_CAR_SPEED 15
//#define MIN_CAR_SPEED 5
//#define MAX_ACC_SPEED MAX_CAR_SPEED
//#define MIN_ACC_SPEED MIN_CAR_SPEED
//
//// define any needed global variables
//// ...
//// ...
//
//
//// This function present the "prompt" string to the user before accepting
//// an integer back from the Serial connection. If the user enters anything
//// other than a digit (e.g. return key, letters), the currently built number
//// is returned
//int read_int(char* prompt) {
//    int number = 0;
//    
//    pc.printf(prompt);
//    
//    char input;
//    while(1) {
//        input = pc.getc();
//        pc.putc(input);
//        
//        if( std::isdigit(input) ) {
//            number = (number * 10) + (input-'0');   
//        } else {
//            pc.putc(input);
//            break;   
//        } 
//    }
//    
//    return number;
//}
//
// void get_valid_input(char* str, int* data, int max, int min)
// {
//    int valid_reading = 0;
//    while( !valid_reading )
//    {
//        *data = read_int(str);   
//        if( *data >= min && *data <= max )
//        {
//            valid_reading = 1;
//        }
//        else
//        {
//            printf("\r\n");
//            printf("invalid input ... range: %d -> %d\r\n", min, max);
//        }  
//    }
//    printf("\r\n");
//}
//
//void handle_input(int* car_pos,int* car_speed,int* acc_speed)
//{
//    get_valid_input("car position: ",car_pos,MAX_CAR_POSITION,MIN_CAR_POSITION);
//    get_valid_input("car_speed: ",car_speed,MAX_CAR_SPEED,MIN_CAR_SPEED);
//    get_valid_input("acc_speed: ",acc_speed,MAX_ACC_SPEED,MIN_ACC_SPEED);
//    return;
//}
//
//// The main thread of the program. This runs the main program, accepting user
//// input, creating cars, displaying state of cars, and handling coordination that
//// may be needed. Timing statistics are also presented.
//int main()
//{   
//    // ------------------------------------------------------------------------------
//    // The following three variables are used for timing statistics, do not modify them
//    Timer stopwatch;    // A timer to keep track of how long the updates take, for statistics purposes
//    int numberCycles = 0;
//    int totalUpdateTime = 0;
//    // ------------------------------------------------------------------------------
//    
//    // prepare serial monitor and make it look nice
//    printf("\033[2J");
//    printf("\r\n");
//    
//    
//    Car car(0);         // Create a car. This call will need to be modified with any additional parameters you add
//    AccCar acc_car(0);
//    
//    stopwatch.start();  // Start out stats timer
//    
//    while (true) {      // Run the simulation indefinitely
//        
//        int carspeed,carposition,acctarget;
//        
//        // get the input
//        handle_input(&carposition,&carspeed,&acctarget);
//
//          //  clear LCD
//          lcd.cls();
//        
//        // create acc and car threads based off user input
//        car.reset(carspeed,carposition);
//        acc_car.reset(acctarget);
//        
//        // ----------------------------------------------------------------------
//        // Timing statistics logic, do not modify
//        stopwatch.reset();
//        // ----------------------------------------------------------------------
//        do {    // Run the simulation until the car exits the road
//;
//            // wait some time before sending signal
//            while(stopwatch.read_ms() < TICK)
//            {
//                // do nothing I guess
//            }
//            
//            // signal car it can update
//            send_signal( CAR_SIGNAL );
//            
//            // wait for car to update
//            wait_for_signal( CAR_UPDATE_MAIN_SIGNAL );
//            
//            // update the ACC car
//            send_signal( ACC_SIGNAL );
//            
//            // wait for the update to complete
//            wait_for_signal( ACC_UPDATE_MAIN_SIGNAL );
//
//            // ------------------------------------------------------------------
//            // Timing statistics logic, do not modify
//            totalUpdateTime += stopwatch.read_ms();
//            numberCycles++;
//            stopwatch.reset();
//            // ------------------------------------------------------------------
//            lcd.cls();
//            // Display the state of the car to the LCD
//            lcd.printf( "Car: %d -> %d\n",car.speed,car.position );
//            lcd.printf( "Acc: %d -> %d\n",acc_car.speed,acc_car.position );
//            
//        } while (acc_car.acc_is_simulating());     // Modify this condition to stop the simulation when the car exits the road
//        
//        // terminate any threads waiting for a signal
//        send_signal( SIG_TERM );
//        
//        // ----------------------------------------------------------------------
//        // Timing statistics printout, do not modify
//        pc.printf("Resetting...\r\n");
//        pc.printf("Average update cycle took: %fms \r\n", (totalUpdateTime*1.0)/(numberCycles*1.0));
//        totalUpdateTime = 0;
//        numberCycles = 0;
//        // ----------------------------------------------------------------------
//    }
//}
